<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>insertUser</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container bg-light">
        <h2 class="text-center">Thêm mới user</h2>
        <div class="row">
            <div class="col-md-6 mx-auto">
                <div class="form-group">
                    <label for="inp-firstname">Firstname</label>
                    <input type="text" class="form-control" name="firstname" id="inp-firstname"
                        placeholder="Enter Firstname">
                </div>
                <div class="form-group">
                    <label for="inp-lastname">Lastname</label>
                    <input type="text" class="form-control" name="lastname" id="inp-lastname"
                        placeholder="Enter Lastname">
                </div>
                <div class="form-group">
                    <label for="select-country">Country</label>
                    <div class="form-group">
                        <select class="form-control" id="select-country">
                            <option value="VN">Vietnam</option>
                            <option value="USA">USA</option>
                            <option value="AUS">Australia</option>
                            <option value="CAN">Canada</option>
                        </select>
                    </div>
                </div>
                <div class="form-group">
                    <label for="select-customer-type">Customer Type</label>
                    <div class="form-group">
                        <select class="form-control" id="select-customer-type">
                            <option value="Standard">Standard</option>
                            <option value="Gold">Gold</option>
                            <option value="Premium">Premium</option>
                        </select>
                    </div>
                </div>
                <div class="form-group">
                    <label for="inp-subject">Subject</label>
                    <input type="text" class="form-control" name="subject" id="inp-subject" row="3"
                        placeholder="Enter Subject">
                </div>
                <div class="form-group">
                    <a href="list-users.html" id="btn-previous-page" class="btn btn-link">Quay lại</a>
                    <button name="btnAddUser" id="btn-add-user" class="btn btn-success float-right">Thêm mới</button>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    /*** REGION 1 - GLOBAL variables */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";

    var gEleFirstName = $("#inp-firstname");
    var gEleLastName = $("#inp-lastname");
    var gEleSubject = $("#inp-subject");
    var gEleCountry = $("#select-country");
    var gEleCustomerType = $("#select-customer-type");
    /*** REGION 2 - Vùng gán/ thực thi sự kiện cho các elements */
    $("#btn-add-user").click(function () {
        console.log("Update user clicked!");
        //B1: Get data
        var vDataAddedObj = getFormData();
        //B2: validate data
        var vIsDataValid = validateFormData(vDataAddedObj);
        if (vIsDataValid) {
            //B3: process update user info
            callAjaxAPIAddUser(vDataAddedObj);
        }
    });

    /*** REGION 3 - Event handlers */
    // hàm thu thập dữ liệu
    function getFormData() {
        var vAddUserInfoObj = new Object();

        vAddUserInfoObj.firstname = $.trim(gEleFirstName.val());
        vAddUserInfoObj.lastname = $.trim(gEleLastName.val());
        vAddUserInfoObj.country = $.trim(gEleCountry.val());
        vAddUserInfoObj.customerType = gEleCustomerType.val();
        vAddUserInfoObj.subject = $.trim(gEleSubject.val());

        return vAddUserInfoObj;
    }
    // hàm kiểm tra dữ liệu
    function validateFormData(paramObjUserData) {
        if (paramObjUserData.firstname == "") {
            alert("Enter Firstname!");
            return false;
        }
        if (paramObjUserData.lastname == "") {
            alert("Enter Lastname!");
            return false;
        }
        if (paramObjUserData.subject == "") {
            alert("Enter Subject!");
            return false;
        }
        if (paramObjUserData.customerType == "") {
            alert("Enter CustomerType!");
            return false;
        }
        if (paramObjUserData.country == "") {
            alert("Enter Country!");
            return false;
        }
        return true;
    }

     // Hàm truy xuất và lấy dữ liệu Usẻr dựa vào UserId
     function callAjaxAPIAddUser(paramDataAddedObj) {
        "use strict";
        //B1: get data 
        //B2: validate data
        //B3: process get User list
        var vJsonString = JSON.stringify(paramDataAddedObj);
        console.log(vJsonString);
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/",
            method: "POST",
            contentType: "application/json;charset=UTF-8",
            data: vJsonString,
            success: function (paramResponse) {
                // Thông báo thêm mới thành công
                alert("User ID:" + paramResponse.id + "Adding Data Sucessful");

                // Khi thêm mới thành công quay trở lại trang danh sách người dùng
                window.location.href = "list-users.html";

                console.log(JSON.stringify(paramResponse, true, 2));
            },
            error: function(ajaxContext){
                console.log(ajaxContext);
            }
        });
        }
</script>

</html>